#include "py_code_tune_lib.h"
#include "Python.h"

#define STRINGIFY(iA)              STRINGIFY_IMPL(iA)
#define STRINGIFY_IMPL(iA)         #iA

#define CONCATENATE( iA, iB )      CONCATENATE_IMPL(iA, iB)
#define CONCATENATE_IMPL( iA, iB ) iA##iB


static PyObject *
pyStartSampling(PyObject *self, PyObject *args)
{
	codetune::startSampling();
    return Py_None;
}

static PyObject *
pyStopSampling(PyObject *self, PyObject *args)
{
	codetune::stopSampling();
    return Py_None;
}

static PyMethodDef pyCodeTuneEventMethods[] = {
    {"startSampling",  pyStartSampling, METH_VARARGS, "Communicates to an attached profiler that sampling can be started."},
    {"stopSampling",  pyStopSampling, METH_VARARGS, "Communicates to an attached profiler that sampling must be stopped."},
    {NULL, NULL, 0, NULL}
};

#if PY_MAJOR_VERSION==2 
PyMODINIT_FUNC
CONCATENATE(initpyCodeTuneEvent2, PY_MINOR_VERSION) (void)
{
    PyObject *m;

    m = Py_InitModule("pyCodeTuneEvent2" STRINGIFY(PY_MINOR_VERSION), pyCodeTuneEventMethods);
    if (m == NULL)
        return;
}
#endif


#if PY_MAJOR_VERSION==3 

static struct PyModuleDef CONCATENATE(pyCodeTuneEventModule3,PY_MINOR_VERSION) = {
   PyModuleDef_HEAD_INIT,
   "pyCodeTuneEvent3" STRINGIFY(PY_MINOR_VERSION),   /* name of module */
   0, /* module documentation, may be NULL */
   -1,       /* size of per-interpreter state of the module,
                or -1 if the module keeps state in global variables. */
   pyCodeTuneEventMethods
};


PyMODINIT_FUNC
CONCATENATE(PyInit_pyCodeTuneEvent3, PY_MINOR_VERSION)(void)
{
    PyObject *m;

    m = PyModule_Create(&CONCATENATE(pyCodeTuneEventModule3,PY_MINOR_VERSION));
    if (m == NULL)
        return NULL;

    return m;
}

#endif